#include<cstdio>
#include<vector>
#include<list>
#include<map>
#include<set>
#include<deque>
#include<bitset>
#include<stack>
#include<algorithm>
#include<functional>
#include<numeric>
#include<utility>
#include<sstream>
#include<iostream>
#include<iomanip>
#include<cstdio>
#include<cmath>
#include<cstdlib>
#include<ctime>
#include<queue>

using namespace std;

#define pb push_back
#define mp make_pair
#define sz(a) ((int)(a.size()))
#define all(a) a.begin(),a.end()
#define eps 1e-11
#define REP(i,n) for(int (i)=0;i<(n);++i)
#define REPS(i,n) for(int(i)=0;i<(n.size());++i)
#define FOR(i,a,b) for(int(i)=(a);i<=(b);++i)
#define FORD(i,a,b) for(int(i)=(a);i>=(b);--i)
#define FORE(it,c) for(__typeof((c).begin()) it=(c).begin();it!=(c).end();++it)


#define se second
#define fi first
#define SQR(a) ((a)*(a))
#define pii pair<int,int>

int N;
double Dist(pii p1, pii p2)
{
	return sqrt(SQR(p1.fi-p2.fi) + SQR(p1.se-p2.se));
}

double CP( pii p1, pii p2, pii p3)
{
	return (p2.fi-p1.fi)*(p3.se-p1.se)-(p3.fi-p1.fi)*(p2.se-p1.se);
}

inline vector<pair<pii,int> > convex(vector<pair<pii,int> > body)
{
	if(sz(body)<4) return body;
	vector<pair<pii,int> > Stack;
	sort( body.begin(), body.end());

	Stack.pb(body[0]);
	Stack.pb(body[1]);
	FOR(i,2,sz(body)-1)
	{
		while(sz(Stack)>1 && CP(Stack[sz(Stack)-2].fi, Stack[sz(Stack)-1].fi, body[i].fi)>=0)
			Stack.pop_back();
		Stack.pb(body[i]);
	}
	int zatial=sz(Stack);
	for(int i=sz(body)-2; i>=0; i--)
	{
		while(sz(Stack)>zatial && CP(Stack[sz(Stack)-2].fi, Stack[sz(Stack)-1].fi, body[i].fi)>=0)
			Stack.pop_back();
		Stack.pb(body[i]);
	}
	Stack.pop_back();
	return Stack;
}

int M,V[20],L[20],v,l,VV,minVV,x,y;
double LL;
vector<pair<pii,int> > B,TEMP;

int main()
{
	while(scanf("%d",&N),N)
	{
		minVV=10000000;
		B.clear();
		REP(i,N)
		{
			scanf("%d %d %d %d",&x,&y,&v,&l); 
			B.pb(mp(mp(x,y),i));
			V[i]=v;
			L[i]=l;
		}

		int mask=(1<<N)-1;
		while(1)
		{
			TEMP.clear();
			VV=0;
			LL=0;
			REP(i,N)
				if(mask&(1<<i))
				{
					TEMP.pb(B[i]);
				}
				else 
				{
					VV+=V[i];
					LL+=L[i];
				}

			
			TEMP=convex(TEMP);
			TEMP.pb(TEMP[0]);

			double aktLL=0.0;
			REP(i,sz(TEMP)-1)
				aktLL+=Dist(TEMP[i].fi,TEMP[i+1].fi);

			if(aktLL-eps<LL && VV<minVV)
				minVV=VV;

//cout<<sz(TEMP)<<" "<<minVV<<endl;

			if (mask==0) break;
			mask--;
		}
			printf("The lost value is %d.\n",minVV);
	}

	return 0;
}
